#ifndef __DRAW_H_
#define __DRAW_H_

/***************************************************************************
 *                                                                         *
 *  draw.h                                                                 *
 *                                                                         *
 ***************************************************************************/

#include "z64pfs.h"

/*--------------------------------------------------------------------------
   Colors
 --------------------------------------------------------------------------*/

#define Col_Black    (GPACK_RGBA5551(0,  0,  0,  1))
#define Col_White    (GPACK_RGBA5551(255,255,255,1))
#define Col_Aqua     (GPACK_RGBA5551(0,  127,127,1))
#define Col_Yellow   (GPACK_RGBA5551(255,255,0,  1))
#define Col_Red      (GPACK_RGBA5551(220,0,  0,  1))
#define Col_Blue     (GPACK_RGBA5551(0,  48, 96, 1))
#define Col_Gray1    (GPACK_RGBA5551(86, 86, 86, 1))
#define Col_Gray2    (GPACK_RGBA5551(32 ,32 ,32 ,1))
#define Col_Gray3    (GPACK_RGBA5551(172,172,172,1))
#define Col_Gray4    (GPACK_RGBA5551(119,119,119,1))

/*--------------------------------------------------------------------------
   External variables
 --------------------------------------------------------------------------*/

extern u16 fntCol;

/*--------------------------------------------------------------------------
   External functions
 --------------------------------------------------------------------------*/

/*
 *  Char-routines
 */

extern void DrawChar(u16 x,u16 y,char chr);
extern void DrawStr(u16 x,u16 y,const char *str);
extern void DrawStrCol(u16 x,u16 y,const char *str,u16 col);
extern void DrawU32(u16 x,u16 y,u32 number,u8 chars);

/*
 *  Line and box-routines
 */

extern void DrawHLine(u16 x,u16 y,u16 size,u16 col);
extern void DrawVLine(u16 x,u16 y,u16 size,u16 col);
extern void DrawFilledBox(u16 x,u16 y,u16 wd,u16 ht,u16 col);
extern void DrawWindow(u16 x,u16 y,u16 wd,u16 ht,const char *title,u16 barCol);

/*--------------------------------------------------------------------------
   Macros
 --------------------------------------------------------------------------*/

#define SetFontColor(col)   \
    fntCol = (col);


#endif   // !__DRAW_H_

