/*
 *  Z64-based receiver
 *
 *  Note: Only a rip of the whole source...
 */

#define DataPort      0x378
#define StatusPort    (DataPort+1)

void ParallelReceive(U8 far *buffer,short size)
{
   for (; size; size--)
   {
      outportb(DataPort,255);
//      delay(10);
      while (inportb(StatusPort) & 128);
      *buffer = (inportb(StatusPort) >> 3) & 0x0F;
      outportb(DataPort,0);
//      delay(10);
      while (!(inportb(StatusPort) & 128));
      *buffer |= (inportb(StatusPort) << 1) & 0xF0;
      buffer++;
   }
}

:

#define BufferSize 16384

long romSize;
U32 romAddr;
short reqBytes;

ParallelReceive((U8 *)&romAddr,4);
ParallelReceive((U8 *)&romSize,4);

while (romSize)
{
   if (romSize > BufferSize)
   {
      reqBytes = BufferSize;
      romSize -= BufferSize;
   }
   else
   {
      reqBytes = romSize;
      romSize = 0;
   }
   ParallelReceive(buffer,reqBytes);
   // -> Buffer to Z64-Dram
}


* Thats all *
