/*---FLASH.CPP---*/
#include"flash\flash.h"
#include<bios.h>
flash_controller::flash_controller(int p0,int p1)
:m_p0(p0),m_p1(p1)
{
  set_status(1);
}
void flash_controller::set_status(int s)
{
  m_status=s;
  m_prev_clk=biostime(0,0);
}
void flash_controller::get_status(int &is_changed,int &new_status)
{
  is_changed=0;
  new_status=m_status;
  if(m_status==0)
  {
    if(biostime(0,0)-m_prev_clk>m_p0)
    {
      set_status(1);
      is_changed=1;
      new_status=1;
    }
  }
  else
  {
    if(biostime(0,0)-m_prev_clk>m_p1)
    {
      set_status(0);
      is_changed=1;
      new_status=0;
    }
  }
}
int flash_controller::get_prev_status()
{
  return m_status;
}
