/*---DOSFILRE.CPP---*/
#include"dosfile.h"
#include<dos.h>
#include<fcntl.h>
// dos file
dos_file::dos_file()
{
  m_fh=0;
  m_opened=0;
}
int dos_file::is_exist(const char *fn)
{
  int fh;
  if(_dos_open(fn,O_RDONLY,&fh)!=0)
    return 0;
  _dos_close(fh);
  return 1;
}
int dos_file::open_create(const char *fn)
{
  if(m_opened)
    return 1;
  if(_dos_creat(fn,_A_NORMAL,&m_fh)!=0)
    return 1;
  m_opened=1;
  return 0;
}
int dos_file::open_read(const char *fn)
{
  if(m_opened)
    return 1;
  if(_dos_open(fn,O_RDONLY,&m_fh)!=0)
    return 1;
  m_opened=1;
  return 0;
}
int dos_file::open_write(const char *fn)
{
  if(m_opened)
    return 1;
  if(_dos_open(fn,O_WRONLY,&m_fh)!=0)
    return 1;
  m_opened=1;
  return 0;
}
int dos_file::read(char far *buf,unsigned len)
{
  if(m_opened==0)
    return 1;
  unsigned nr;
  if((_dos_read(m_fh,buf,len,&nr)==0) && nr==len)
    return 0;
  return 1;
}
int dos_file::write(const char far *buf,unsigned len)
{
  if(m_opened==0)
    return 1;
  unsigned nw;
  if((_dos_write(m_fh,(void far*)buf,len,&nw)==0) && nw==len)
    return 0;
  return 1;
}
void dos_file::close()
{
  if(m_opened)
    _dos_close(m_fh);
  m_opened=0;
}
