/*---IPS_DEC.H---*/
#ifndef _INC_IPS_DEC
#define _INC_IPS_DEC
enum IPS_command_type
{
  IPS_error,  // IPS decoder error
  IPS_next,   // no operation, read next data
  IPS_end,    // IPS decoder ended
  IPS_copy,   // copy data from source
  IPS_fill    // fill data
};
struct IPS_command
{
  IPS_command_type type;
  unsigned long addr;
  union
  {
    unsigned copy_cnt;  // number of bytes to copy
    struct
    {
      unsigned cnt;        // number of data to fill
      unsigned char data;  // data to fill
    }fill;
  };
};
//
class IPS_decoder
{
  public:
    IPS_decoder();
    // get number of bytes to read from file
    int get_request_data_size();
    // send data from file to decoder, get command from decoder
    void send_data(const unsigned char far *data,IPS_command &cmd);
  private:
    int m_state;
    long m_addr;
};
#endif
