/*---Z64DEL.CPP---*/
#include"z64del.h"
#include"z64_gbl.h"
#include"z64const.h"
#include"z64_util.h"
//
const opt_exit_del=0;
const opt_del_file=1;
// delete file
int delete_file(Z64_file_info &info)
{
	// Prompt user
  p_disp->clear();
	show_file_title(info.get_title());
  p_disp->gotoxy(1,2);
  if(info.get_type()!=BIOS_file)
    p_disp->printf("%3dM DELETE?",info.get_rom_size()/megabit);
  else
    p_disp->printf("DELETE?");
  int ret;
  ret=ask_yes_no(14,2,1);
  if(ret!=0)
    return 1;
  p_filesys->delete_file(info);
  return 0;
}
//
void select_del_file_menu::run()
{
	del_file_menu_list l;
  select_file_menu::run(&l,opt_del_file);
}
int select_del_file_menu::handle_key(int k,int pos,Z64_file_info &info)
{
  if(k!=EnterKey)
    return 0;
  if(pos>=opt_del_file)
	{
    if(delete_file(info))
    {
      p_disp->clear();
      return 0;
		}
  }
  p_disp->clear();
  return 1;
}
