#ifndef _Z64_IO_H_///
#define _Z64_IO_H_///
/*---Z64_IO.H---*/
#include"lcd\textlcd.h"
// Z64 display device
class Z64_display_device
{
  public:
    virtual void clear()=0;
    virtual void gotoxy(int x,int y)=0;
    virtual void printf(const char *fmt,...)=0;
    virtual void read(char *buf,int sz)=0;
    virtual void set_font(int code,char *buf){}
};
class Z64_display_VGA:public Z64_display_device
{
  public:
    void init();
    void clear();
    void gotoxy(int x,int y);
    void printf(const char *fmt,...);
    void read(char *buf,int sz);
};
class Z64_display_LCD:public Z64_display_device
{
  public:
    Z64_display_LCD(Text_LCD_interface *pif);
    void init();
    void clear();
    void gotoxy(int x,int y);
    void printf(const char *fmt,...);
    void read(char *buf,int sz);
    void set_font(int code,char *buf);
  private:
    Text_LCD m_lcd;
};
// Z64 Keypad
enum
{
  NoKey,UpKey,DownKey,EnterKey,BothKey
};
class Z64_keypad_device
{
  public:
    virtual int read_key()=0;
};
class Z64_keypad_keyboard:public Z64_keypad_device
{
  public:
    int read_key();
};
class Z64_keypad_8255:public Z64_keypad_device
{
  public:
    Z64_keypad_8255();
    int read_key();
  private:
    unsigned char read_keyswitch();
    unsigned char read_keyswitch_debounce();
    void key_beep();
    int m_wait_release_key;
};
#endif///