/*---Z64_UTIL.H---*/
#ifndef _INC_Z64_UTIL
#define _INC_Z64_UTIL
#include"z64_file.h"
struct option
{
  int x;
  char *str;
};
int file_exist(const char *fn);
int  wait_power(const char *prompt,int pwr);
void wait_power_off(const char *prompt);
void wait_power_on(const char *prompt);
void wait_cart();
void show_msg_wait_enter(const char *msg);
void get_center_str(char *buf,const char *src);
const char *get_center_str(const char *src);
void show_center_str(const char *src);
void show_center_str(int y,const char *src);
void clear_line(int line);
const char *get_center_title(const char *title);
void show_file_title(const char *title);
int ask_yes_no(int x,int y,int def_opt=0);
void show_error_msg_wait_enter(const char *msg);
void load_file_error();
void write_file_error();
void disk_not_ready();
void disk_space_not_enough();
void no_eeprom_warning();
void success_sound();
void prompt_sound();
void error_sound();
void test_error_sound(int cnt);
void test_ok();
void shift_display(int y,const char *new_buf,int dir=0);
int wait_change_disk();
void show_option(option &opt,int st);
int select_option(option *opt,int opt_num,int init_sel=0);
void process_file_init_progress(unsigned long sz);
void process_file_update_progress(unsigned long sz);
void clear_file_update_progress();
int write_cart_SRAM_to_SRAM_file();
int write_DRAM_mapped_SRAM_to_SRAM_file();
int load_SRAM_file();
void save_original_DRAM_mapped_SRAM();
int is_SRAM_modified();
void auto_backup_SRAM(Z64_file_info &info);
#endif
