/*---ASPIDEV.H---*/
#ifndef _INC_ASPIDEV
#define _INC_ASPIDEV
#include"aspi\aspidrv.h"
// ASPI Device
class CASPI_Device
{
  public:
    // Constructors
    CASPI_Device();
    CASPI_Device(ASPI_Driver *pASPI);
    CASPI_Device(ASPI_Driver *pASPI,const Thread &thread);
    // Set pointer to ASPI driver
    ASPI_Driver *SetASPI_Driver(ASPI_Driver *pASPI);
    // Get pointer to ASPI driver
    ASPI_Driver *GetASPI_Driver();
    // Set device thread
    Thread SetThread(const Thread &thread);
    // Get device thread
    Thread GetThread();
    // Call TEST UNIT READY
    WORD TestUnitReady();
    WORD TestUnitReady(SenseData &sd);
    // Call MODE SENSE to read Block Descriptor and Page Data
    WORD ModeSense(int PageCode,BlkDes *BD,BYTE *AllocPtr,BYTE AllocLen);
    // Call MODE SENSE to read specified Page Data
    WORD ModeSenseReadPage(int PageCode,BYTE *AllocPtr,BYTE AllocLen);
    // Call MODE SELECT to set Block Descriptor
    WORD ModeSelectSetBlkDes(BlkDes *BD);
    // Call MODE SELECT to set specified Page data
    WORD ModeSelectSetPage(BYTE *AllocPtr,BYTE AllocLen);
  private:
    ASPI_Driver *m_pASPI;  // Pointer to ASPI Driver
    Thread m_Thread;       // Device thread
};
#endif  // _NC_ASPIDEV
