/*---TEXTLCD.H---*/
#ifndef _INC_TEXTLCD
#define _INC_TEXTLCD
// Text_LCD interface class
class Text_LCD_interface
{
  public:
    virtual void write_cmd(unsigned char cmd)=0;
    virtual unsigned char read_status()=0;
    virtual void write_data(unsigned char data)=0;
    virtual unsigned char read_data()=0;
};
// Text LCD configuration parameter
class Text_LCD_config
{
  public:
    Text_LCD_config();
    int display_on;
    int cursor_on;
    int blink_char;
    int display_lines;
};
// Text_LCD class
class Text_LCD
{
  public:
    Text_LCD(Text_LCD_interface *pif);
    void clear_screen();
    void home();
    void entry_mode_set(int I_D,int S);
    void display_control(int D,int C,int B);
    void shift(int S_C,int R_L);
    void function_set(int DL,int N,int F);
    void set_CG_RAM_addr(unsigned char addr);
    void set_DD_RAM_addr(unsigned char addr);
    void set_font(int fnt_code,char *fnt_buf);
    void write_char(unsigned char char_code);
    void write_str(unsigned char *str);
    void read_str(unsigned char *str,int sz);
    void set_config(const Text_LCD_config &cfg);
    void gotoxy(int x,int y);
    int printf(const char *fmt,...);
  private:
    int is_LCD_ready();
    Text_LCD_interface *m_pif;
};
#endif  // _INC_TEXTLCD
