#ifndef __RAM_H_
#define __RAM_H_

/***************************************************************************
 *                                                                         *
 *  ram.h                                                                  *
 *                                                                         *
 ***************************************************************************/

#include "basetype.h"

/*--------------------------------------------------------------------------
   Constants
 --------------------------------------------------------------------------*/

/*
 *  Access-rights
 */

enum {
   N64_ROM = 0,N64_Dram,PC_ROM,PC_Dram,   // HW 1+2
   N64_32M_ROM,UserBios,                  // Only HW 2
   PC_SramRead,PC_SramWrite     	  // To read/write mapped SRAM
};

/*
 *  Access-IDs (used in the ramread/write-routines)
 */

enum {
   Ram_ROM = 0,
   Ram_Dram,
   Ram_SramCart,
   Ram_SramMapped
};

/*--------------------------------------------------------------------------
   External functions
 --------------------------------------------------------------------------*/

extern void RamSetMemoryAddress(U32 addr);
extern U32  RamGetMemoryAddress(void);
extern Bool RamSetMemoryRights(U16 right);
extern Bool RamWriteBuffer(char dstID,U32 dstOfs,void far *buffer,U16 size);

/*--------------------------------------------------------------------------
   Macros
 --------------------------------------------------------------------------*/


#endif   // !__RAM_H_
