#ifndef __BINUTIL_H_
#define __BINUTIL_H_

/***************************************************************************
 *                                                                         *
 *  binutil.h                                                              *
 *                                                                         *
 ***************************************************************************/

#include "basetype.h"

/*--------------------------------------------------------------------------
   BinUtil-structure
 --------------------------------------------------------------------------*/

typedef struct _BinUtil {
   char   ext[5];
   char   type;
   char   *actionStr;
   char   *binStr;
   long   titleAddr;
   char   titleLen;
} BinUtil;

/*--------------------------------------------------------------------------
   Constants
 --------------------------------------------------------------------------*/

/*
 *  Configurationpositions
 */

enum {
   Bin_EFS = 0,
   Bin_EMU,
   Bin_JBE,
   Bin_Z64
};

/*--------------------------------------------------------------------------
   External variables and functions
 --------------------------------------------------------------------------*/

/*
 *  Variables
 */

extern BinUtil *binUtil;
extern int binUtilNumber;

/*
 *  Functions
 */

extern void BinUtilInit(void);
extern void BinUtilClose(void);
extern void BinUtilList(void);
extern int  BinUtilOpen(const char *fname);


#endif   // !__BINUTIL_H_

