#ifndef __CONFIG_H_
#define __CONFIG_H_

/***************************************************************************
 *                                                                         *
 *  config.h                                                               *
 *                                                                         *
 ***************************************************************************/

#include "basetype.h"

/*--------------------------------------------------------------------------
   Constants
 --------------------------------------------------------------------------*/

/*
 *  Number of configuration-entries
 */

#define ConfigNum   7

/*
 *  Configurationpositions
 */

enum {
   Sound = 0,
   Eeprom,Sram,CDSave,
   Fastload,Palfix,
   Devmode
};

/*
 *  Menu-IDs for the config-entries
 */

#define OnlyBool(x)    (128 | (x))
#define IsBool(x)      (128 & (x))

#define MCfgSound      OnlyBool(Sound)
#define MCfgEeprom        Eeprom
#define MCfgSram 	  Sram
#define MCfgCDSave	  CDSave
#define MCfgFastload      Fastload
#define MCfgPalfix     OnlyBool(Palfix)
#define MCfgDevmode    OnlyBool(Devmode)

/*
 *  Values for the byte-values
 */

#define Ask      0
#define Always   1
#define Never    2

/*--------------------------------------------------------------------------
   Extern variable and functions
 --------------------------------------------------------------------------*/

/*
 *  Variables
 */

extern U8 config[ConfigNum];

/*
 *  Functions
 */

extern void ConfigRead(void);
extern void ConfigWrite(void);
extern void ConfigUpdateStr(U8 no);
extern void ConfigChange(U8 no);


#endif   // !__CONFIG_H_

