#ifndef __DOSFILE_H_
#define __DOSFILE_H_

/***************************************************************************
 *                                                                         *
 *  dosfile.h                                                              *
 *                                                                         *
 ***************************************************************************/

#include "basetype.h"

/*--------------------------------------------------------------------------
   Structures
 --------------------------------------------------------------------------*/

/*
 *  Disk-information (int 21h,69h)
 */

typedef struct _DiskInfo {
   U16    infoLevel;
   U32    diskSerial;
   char   label[11];
   char   fileType[8];
} DiskInfo;

/*--------------------------------------------------------------------------
   Extern variable and functions
 --------------------------------------------------------------------------*/

/*
 *  Variables
 */

extern Bool driveReadOnly;
extern U32  diskSerial;

/*
 *  Functions
 */

extern long FileSize(int handle);
extern int  FileOpenExt(char *fn,char *fext);
extern U16  FileGetID(char *fname);
extern Bool FileRead(char *fname,long offset,char *buffer,U16 size);

extern Bool DiskGetInfo(U8 num);
extern U32  DiskGetFreeSpace(void);

#endif   // !__DOSFILE_H_

