/***************************************************************************
 *                                                                         *
 *  menu.inc                                                               *
 *                                                                         *
 *  The main- and submenus     		                                   *
 *                                                                         *
 *  Note: Is included from "menu.cpp"                                      *
 *                                                                         *
 ***************************************************************************/

/*--------------------------------------------------------------------------
   The menu-parameters
 --------------------------------------------------------------------------*/

const MenuParam DefMenuParam[] = {
   { 0,3, B_AllTypes},   // Main
   { 3,3, B_OnlyMenu},   // Misc
   { 6,10,B_OnlyMenu},   // Config
   {16,3, B_OnlyMenu}    // ZIP-tools
};

/*--------------------------------------------------------------------------
   The menu-entries
 --------------------------------------------------------------------------*/

const MenuEntry DefMenu[] = {

   // Main-menu (0)

   {"<Miscellaneous>",     M_SubMenu,   0,1           },
   {"<Backup cartridge>",  M_MenuAction,0,1           },
   {"<Play cartridge>",    M_MenuAction,0,2           },

   // Miscellaneous (1)

   {"<Exit>",              M_SubMenu,   0,0           },
   {"<Configuration>",     M_SubMenu,   0,2           },
   {"<ZIP-tools>",         M_SubMenu,   0,3           },

   // Configuration (2)

   {"<Exit to main-menu>", M_SubMenu,   0,0           },
   {"<Exit to misc.>",     M_SubMenu,   0,1           },
   {"Z64-Speaker:",        M_Config,    0,MCfgSound   },
   {"Backup EEPROM:",      M_Config,    0,MCfgEeprom  },
   {"Backup SRAM:",        M_Config,    0,MCfgSram    },
   {"CD-Savegames:",	   M_Config,    0,MCfgCDSave  },
   {"Fast-load:",	   M_Config,    0,MCfgFastload},
   {"Auto-Palfix:",        M_Config,    0,MCfgPalfix  },
   {"Dev-mode:",	   M_Config,    0,MCfgDevmode },
   {"<Save configuration>",M_MenuAction,0,3           },

   // ZIP-tools (3)

   {"<Exit to main-menu>", M_SubMenu,   0,0  	    },
   {"<Exit to misc.>",     M_SubMenu,   0,1  	    },
   {"Format disk",         M_MenuAction,0,4  	    }
};

