/***************************************************************************
 *                                                                         *
 *  menufx.cpp                                                             *
 *                                                                         *
 *  Menu-effects (pretty simple)					   *
 *                                                                         *
 ***************************************************************************/

#include "all_inc.h"

/*--------------------------------------------------------------------------
   EffectInit - Effect-initialisation, for internal use only
 --------------------------------------------------------------------------*/

char EffectInit(char *txt,Bool centered)
{
   memset(screenLine[0],' ',20);
   screenLine[0][20] = 0;
   if (centered)
      return((20-strlen(txt)) >> 1);
   return(0);
}

/*--------------------------------------------------------------------------
   MfxIn1 - Char by char
 --------------------------------------------------------------------------*/

void MfxIn1(char lineNo,char *txt,Bool centered)
{
   char destX = EffectInit(txt,centered);
   char loop;

   while (*txt)
   {
      screenLine[lineNo][19] = *txt;
      for (loop = 19; loop >= destX; loop--)
      {
	 screenLine[lineNo][loop] = *txt;
	 if (loop < 19)
	    screenLine[lineNo][loop+1] = ' ';
	 LCDPutsXY(1,1+lineNo,screenLine[lineNo]);
	 delay(10);
      }
      destX++;
      txt++;
   }
}

/*--------------------------------------------------------------------------
   MfxIn2 - Scrolls text
 --------------------------------------------------------------------------*/

void MfxIn2(char lineNo,char *txt,Bool centered)
{
   char destX = EffectInit(txt,centered);
   char currX,charNum = 1,loop;

   for (currX = 19; currX >= destX; currX--)
   {
      for (loop = 0; loop < charNum; loop++)
      {
	 if (loop >= strlen(txt))
	    screenLine[lineNo][currX+loop] = ' ';
	 else
	    screenLine[lineNo][currX+loop] = txt[loop];
      }
      LCDPutsXY(1,1+lineNo,screenLine[lineNo]);
      delay(30);
      charNum++;
   }
}

/*--------------------------------------------------------------------------
   MfxIn3 - Ascii-code-modification
 --------------------------------------------------------------------------*/

void MfxIn3(char lineNo,char *txt,Bool centered)
{
   char destX = EffectInit(txt,centered);
   char loop,loop2;

   for (loop = 0; loop < strlen(txt); loop++)
      screenLine[lineNo][destX+loop] = txt[loop]+40;

   for (loop = 0; loop < 40; loop++)
   {
      for (loop2 = 0; loop2 < strlen(txt); loop2++)
	 screenLine[lineNo][destX+loop2]--;
      LCDPutsXY(1,1+lineNo,screenLine[lineNo]);
      delay(7);
   }
}

/*--------------------------------------------------------------------------
   MfxIn4 - Build string from inside
 --------------------------------------------------------------------------*/

void MfxIn4(char lineNo,const char *txt)
{
   char actX,minus = 0;
   char loop,loop2;

   /*
    *  1. Write string
    */

   actX = 9;
   for (loop = 0; loop < strlen(txt); loop++)
   {
      if (minus)
      {
	 screenLine[lineNo][actX+loop] = txt[loop];
	 actX--;
      }
      else
      {
	 for (loop2 = 0; loop2 <= loop; loop2++)
	    screenLine[lineNo][actX+loop2] = txt[loop2];
      }
      LCDPutsXY(1,1+lineNo,screenLine[lineNo]);

      minus ^= 1;
      delay(20);
   }

   /*
    *  3. Fill with spaces - after
    */

   for (loop = ((20-strlen(txt)) / 2)+(strlen(txt) % 2); loop; loop--)
   {
      if (loop)
	 screenLine[lineNo][loop-2] = ' ';
      screenLine[lineNo][20-loop] = ' ';
      LCDPutsXY(1,1+lineNo,screenLine[lineNo]);
      delay(20);
   }
}

/*--------------------------------------------------------------------------
   MfxOut1 - Clears string from left, char by char
 --------------------------------------------------------------------------*/

void MfxOut1(char lineNo)
{
   LCDGotoXY(1,1+lineNo);
   for (char loop = 0; loop < 20; loop++)
   {
      LCDWriteChar(' ');
      delay(20);
   }
}

/*--------------------------------------------------------------------------
   MfxOut2 - Like closing a door
 --------------------------------------------------------------------------*/

void MfxOut2(char lineNo)
{
   for (char loop = 0; loop < 10; loop++)
   {
      LCDGotoXY(1+loop,1+lineNo);
      LCDWriteChar(' ');
      LCDGotoXY(20-loop,1+lineNo);
      LCDWriteChar(' ');
      delay(50);
   }
}

