#ifndef __ZIPFILE_H_
#define __ZIPFILE_H_

/***************************************************************************
 *                                                                         *
 *  zipfile.h                                                              *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>   // Should be substituded with "all_inc.h"
#include <string.h>
#include <alloc.h>

/*--------------------------------------------------------------------------
   Own types
 --------------------------------------------------------------------------*/

typedef unsigned char    Byte,U8;
typedef unsigned short   Word,U16;
typedef unsigned long    Dword,U32;

typedef char   Bool;

enum { False = 0,True };

/*--------------------------------------------------------------------------
   Own structures
 --------------------------------------------------------------------------*/

/*
 *  Zip-Header (not the whole thing, no ID+Versionsnummer)
 */

typedef struct _ZipHeader {
   U16    compression;
   U32	  date;
   U32	  crc32;
   U32    compressed;
   U32	  uncompressed;
   U16	  lenFilename;
   U16    lenExtra;
} ZipHeader;


/*
 *  ZIP-entry-description (not in a ZIP-file)
 */

typedef struct _ZipDesc {
   Bool   stored;
   U32    compressed;
   U32	  uncompressed;
   long   offset;
} ZipDesc;

/*--------------------------------------------------------------------------
   External variables and functions
 --------------------------------------------------------------------------*/

/*
 *  Variables
 */

extern Bool    zipMode;
extern FILE    *zipFile;
extern ZipDesc *zipfileDesc;
extern int     zipfileNum;

/*
 *  Functions
 */

extern Bool EnterZipMode(char *fname);
extern void ExitZipMode(void);


#endif   // !__ZIPFILE_H_
