/*
 *  ziplist.cpp
 *
 *  Tests "zipfile.h"
 *  Ravemax/Dextrose
 */

#include <stdio.h>
#include "zipfile.h"

/*--------------------------------------------------------------------------
   MenuAddItem() - Just a fake for the real menu-function
 --------------------------------------------------------------------------*/

void MenuAddItem(const char *str)
{
   static num = 0;

   num++;
   printf("(%d) '%s'\n",num,str);
}

/*-------------------------------------------------------------------------
   OutputZipDesc() - Just some information
 -------------------------------------------------------------------------*/

void OutputZipDesc(void)
{
   int loop;

   puts("\n--( ZIP Desc )--\n");
   for (loop = 0; loop < zipfileNum; loop++)
   {
      printf("%d\n",loop+1);
      printf("  Only stored : %s\n",(zipfileDesc[loop].stored) ? "Yes" : "No");
      printf("  Size comp   : %ld\n",zipfileDesc[loop].compressed);
      printf("  Size uncomp : %ld\n",zipfileDesc[loop].uncompressed);
      printf("  Offset      : 0x%lX\n",zipfileDesc[loop].offset);
   }
}

/*--------------------------------------------------------------------------
   main()
 --------------------------------------------------------------------------*/

int main(int argc,char *argv[])
{
   puts("ZIP-List\n");
   if (argc != 2)
   {
      puts("Usage: ZIPLIST zip\n");
      return(1);
   }

   puts("--( Virtual directory )--\n");
   if (!EnterZipMode(argv[1]))
   {
      puts("Error: I/O failure\n");
      return(2);
   }
   OutputZipDesc();
   ExitZipMode();

   return(0);
}
